var Exif = require('exif');
var ExifImage = Exif.ExifImage;
var exif_header_offset = 12;

function get_latlng(file_name, cb) {
	try {
		new ExifImage({ image: file_name }, function (error, exifData) {
			let latlng = "-1,-1";
			if (error) {
				console.log('Error: ' + error.message);
			}
			else {
				let orientation = exifData.image.Orientation;
				let lat_r = exifData.gps.GPSLatitudeRef;
				let latitude = 0;
				if (exifData.gps.GPSLatitude) {
					latitude = exifData.gps.GPSLatitude[0] + exifData.gps.GPSLatitude[1] / 60.0 + exifData.gps.GPSLatitude[2] / 3600.0;
				}
				if (lat_r != "N") {
					latitude = 0 - latitude;
				}
				let lon_r = exifData.gps.GPSLongitudeRef;
				let longtitude;
				if (exifData.gps.GPSLongitude) {
					longtitude = exifData.gps.GPSLongitude[0] + exifData.gps.GPSLongitude[1] / 60.0 + exifData.gps.GPSLongitude[2] / 3600.0;
				}
				if (lon_r != "E") {
					longtitude = 0 - longtitude;
				}
				latlng = latitude + "," + longtitude;
			}
			cb(null, latlng);
		});
	}
	catch (error) {
		console.log('Error ' + error.message);
		cb(error, null);
	}
}

module.exports = {
	get_latlng
};
