var google = require('googleapis');
var sampleClient = require('./sampleclient');
var readline = require('readline');
var async = require('async');
var dateformat = require('dateformat');

var auth = sampleClient.oAuth2Client;
var fusiontables = google.fusiontables({ version: 'v2', auth: auth });

var scopes = ['https://www.googleapis.com/auth/fusiontables',
	'https://www.googleapis.com/auth/fusiontables.readonly'
];
var refresh_interval = 60 * 45 * 1000;
var token = null;
var tablename = "PhotoLocation";

var debug = false;

function get_token(cb) {
	sampleClient.execute(scopes, function (err, tokens) {
		token = tokens;
		if (!err) {
			setInterval(
				function () {
					sampleClient.refresh(function (err, t) {
						token = t;
					})
				},
				refresh_interval);
		}
		cb(err);
	});
}

function list(cb) {
	let sql = "show tables;";
	fusiontables.query.sql({ sql: sql }, function (err, res, r) {
		res.rows.forEach(function (item, index, array) {
			if (item[1] === "mapserver") {
				console.log("tableid = " + item[0]);
			}
		});
		cb(res);
	});
}

function get_tableid(tablename, cb) {
	let sql = "show tables;";
	fusiontables.query.sql({ sql: sql }, function (err, res, r) {
		let tid = null;
		res.rows.forEach(function (item, index, array) {
			if (item[1] === tablename) {
				tid = item[0];
			}
		});
		cb(tid);
	});
}

function get_id(tid, name, cb) {
	let sql = "select rowid from " + tid + " where name = '" + name + "';";
	fusiontables.query.sql({ sql: sql }, function (err, res) {
		let col = res.columns;
		if (res.rows && res.rows.length === 1) {
			let index = col.indexOf('rowid');
			let rowid = res.rows[0][index];
			cb(rowid);
		}
		else {
			console.log("select where failed");
			cb(null);
		}
	});
}

function get(tid, col, val, cb) {
	let sql = "select rowid,name,file,Location from " + tid + " where " + col + " = '" + val + "';";
	console.log(sql);
	fusiontables.query.sql({ sql: sql }, function (err, res) {
		console.log(res);
		if (res && res.rows && res.rows.length === 1) {
			let col = res.columns;
			cb([col, res.rows[0]]);
		}
		else {
			console.log("select where failed");
			cb(null);
		}
	});
}

function get_by_name(tid, name, cb) {
	return get(tid, 'name', name, cb);
}

function get_by_file(tid, file, cb) {
	return get(tid, 'file', file, cb);
}

function put(tid, rec, cb) {
	let sql = "insert into " + tid + " (name, file, Location) VALUES ('" + rec.name + "', '" + rec.file + "', '" + rec.Location + "');";
	fusiontables.query.sql({ sql: sql }, function (err, res, r) {
		cb(err);
	});
}

function update(tid, id, rec, cb) {
	let sql = "update " + tid + " set name = '" + rec.name + "', file = '" + rec.file + "',Location = '" + rec.Location + "' where rowid = '" + id + "';";
	fusiontables.query.sql({ sql: sql }, function (err, res) {
		cb(err);
	});
}

function delete_by_id(tid, id, cb) {
	let sql = "delete from " + tid + " where rowid='" + id + "';";
	fusiontables.query.sql({ sql: sql }, function (err, res) {
		cb(err);
	});
}

module.exports = {
	get_token,
	list,
	get_tableid,
	put,
	update,
	get_id,
	get_by_name,
	get_by_file,
	delete_by_id,
};
