var express = require('express');
var router = express.Router();
var config = global.CONFIG;

/* マップ表示 */
router.get('/', function (req, res, next) {
	res.render('map', { title: '撮影地マップ', apikey: config.APIKEY, tableid: global.TABLE_INFO.tableid });
});

/* 撮影場所表示 */
router.get('/place', function (req, res, next) {
	let latlng = req.query.latlng || "";	// 撮影地
	// 撮影場所をマークするためのGoogle Maps API呼び出しを準備
	let map = "https://maps.googleapis.com/maps/api/staticmap?markers=" + latlng + "&zoom=16&size=400x400&key=" + config.APIKEY;

	res.render('map_place', { title: ' 撮影場所', mapview: map });
});

/* ルート表示 */
router.get('/route', function (req, res, next) {
	let from = global.CONFIG.ORIGIN;	// 出発地
	let to = req.query.destination || "";	// 目的地
	// ルート表示するためのGoogle Maps API呼び出しを準備
	let map = "https://www.google.com/maps/embed/v1/directions?key=" + config.APIKEY + "&origin=" + from + "&destination=" + to;
	res.render('map_route', { title: 'ルート表示', origin: from, destination: to, sview: map });
});

module.exports = router;
